#!/usr/bin/env python

import gtk
import gtk.glade
import gobject
import subprocess
import os
import pickle

gladefile="""<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE glade-interface SYSTEM "glade-2.0.dtd">
<!--Generated with glade3 3.4.0 on Sun Nov 30 18:35:31 2008 -->
<glade-interface>
  <widget class="GtkWindow" id="window1">
    <property name="visible">True</property>
    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
    <property name="border_width">6</property>
    <property name="title" translatable="yes">GtkNetSource</property>
    <property name="resizable">False</property>
    <signal name="destroy" handler="close_window"/>
    <child>
      <widget class="GtkTable" id="table5">
        <property name="visible">True</property>
        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
        <property name="n_rows">2</property>
        <property name="n_columns">2</property>
        <property name="column_spacing">4</property>
        <child>
          <widget class="GtkLabel" id="info">
            <property name="visible">True</property>
            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
            <property name="xalign">0.10999999940395355</property>
            <property name="label" translatable="yes">&lt;b&gt;Status:&lt;/b&gt;Deactivated</property>
            <property name="use_markup">True</property>
            <property name="width_chars">50</property>
            <property name="single_line_mode">True</property>
          </widget>
          <packing>
            <property name="right_attach">2</property>
            <property name="top_attach">1</property>
            <property name="bottom_attach">2</property>
            <property name="y_padding">8</property>
          </packing>
        </child>
        <child>
          <widget class="GtkButton" id="prefs_button">
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="receives_default">True</property>
            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
            <property name="label" translatable="yes">gtk-preferences</property>
            <property name="use_stock">True</property>
            <property name="response_id">0</property>
            <signal name="clicked" handler="prefs"/>
          </widget>
          <packing>
            <property name="left_attach">1</property>
            <property name="right_attach">2</property>
            <property name="x_options">GTK_FILL</property>
            <property name="y_options"></property>
          </packing>
        </child>
        <child>
          <widget class="GtkButton" id="start_button">
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="receives_default">True</property>
            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
            <property name="response_id">0</property>
            <signal name="clicked" handler="start"/>
            <child>
              <widget class="GtkLabel" id="start_label">
                <property name="visible">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="xalign">0.05000000074505806</property>
                <property name="label" translatable="yes">Start/Stop</property>
              </widget>
            </child>
          </widget>
          <packing>
            <property name="y_options">GTK_FILL</property>
          </packing>
        </child>
      </widget>
    </child>
  </widget>
  <widget class="GtkDialog" id="configdialog">
    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
    <property name="border_width">5</property>
    <property name="modal">True</property>
    <property name="window_position">GTK_WIN_POS_CENTER_ON_PARENT</property>
    <property name="destroy_with_parent">True</property>
    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
    <signal name="close" handler="config_cancel"/>
    <child internal-child="vbox">
      <widget class="GtkVBox" id="dialog-vbox1">
        <property name="visible">True</property>
        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
        <property name="spacing">2</property>
        <child>
          <widget class="GtkTable" id="table1">
            <property name="visible">True</property>
            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
            <property name="n_rows">2</property>
            <property name="n_columns">3</property>
            <property name="column_spacing">8</property>
            <property name="row_spacing">9</property>
            <child>
              <widget class="GtkFrame" id="frame3">
                <property name="visible">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="label_xalign">0</property>
                <property name="shadow_type">GTK_SHADOW_NONE</property>
                <child>
                  <widget class="GtkAlignment" id="alignment2">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <property name="yscale">0.75</property>
                    <property name="bottom_padding">32</property>
                    <child>
                      <widget class="GtkTable" id="table4">
                        <property name="visible">True</property>
                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                        <property name="border_width">10</property>
                        <property name="n_rows">3</property>
                        <property name="n_columns">3</property>
                        <property name="column_spacing">7</property>
                        <property name="row_spacing">5</property>
                        <child>
                          <widget class="GtkLabel" id="label16">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">periods</property>
                          </widget>
                          <packing>
                            <property name="left_attach">2</property>
                            <property name="right_attach">3</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label15">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">bytes/period</property>
                          </widget>
                          <packing>
                            <property name="left_attach">2</property>
                            <property name="right_attach">3</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="latency">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">1 0 500 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label14">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Latency:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="quality">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0.019999999552965164</property>
                            <property name="adjustment">2 2 1024 2 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkComboBox" id="linktype">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="items" translatable="yes">Celt
float
16bit</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label12">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Compress to:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label11">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Type:</property>
                          </widget>
                        </child>
                      </widget>
                    </child>
                  </widget>
                </child>
                <child>
                  <widget class="GtkLabel" id="label100">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <property name="label" translatable="yes">&lt;b&gt;Link&lt;/b&gt;</property>
                    <property name="use_markup">True</property>
                  </widget>
                  <packing>
                    <property name="type">label_item</property>
                  </packing>
                </child>
              </widget>
              <packing>
                <property name="x_padding">12</property>
                <property name="y_padding">12</property>
              </packing>
            </child>
            <child>
              <widget class="GtkFrame" id="frame2">
                <property name="visible">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="label_xalign">0</property>
                <property name="shadow_type">GTK_SHADOW_NONE</property>
                <child>
                  <widget class="GtkAlignment" id="alignment1">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <property name="xscale">0.89999997615814209</property>
                    <property name="yscale">0.89999997615814209</property>
                    <property name="top_padding">6</property>
                    <child>
                      <widget class="GtkTable" id="table3">
                        <property name="visible">True</property>
                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                        <property name="n_rows">3</property>
                        <property name="n_columns">4</property>
                        <property name="row_spacing">5</property>
                        <child>
                          <widget class="GtkLabel" id="label10">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Reply Port:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label9">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Port:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkEntry" id="hostname">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="text" translatable="yes">host.jack.net</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">4</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label8">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Hostname:</property>
                          </widget>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="port">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">3002 0 65535 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">3</property>
                            <property name="right_attach">4</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="replyport">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">3001 0 65535 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">3</property>
                            <property name="right_attach">4</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkRadioButton" id="portdefault">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="label" translatable="yes">Default</property>
                            <property name="response_id">0</property>
                            <property name="active">True</property>
                            <property name="draw_indicator">True</property>
                            <property name="group">portcustom</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                            <property name="x_options">GTK_FILL</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkRadioButton" id="portcustom">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="label" translatable="yes">Custom:</property>
                            <property name="response_id">0</property>
                            <property name="active">True</property>
                            <property name="draw_indicator">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">2</property>
                            <property name="right_attach">3</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkRadioButton" id="replydefault">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="label" translatable="yes">Default</property>
                            <property name="response_id">0</property>
                            <property name="active">True</property>
                            <property name="draw_indicator">True</property>
                            <property name="group">replycustom</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkRadioButton" id="replycustom">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="label" translatable="yes">Custom:</property>
                            <property name="response_id">0</property>
                            <property name="active">True</property>
                            <property name="draw_indicator">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">2</property>
                            <property name="right_attach">3</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                      </widget>
                    </child>
                  </widget>
                </child>
                <child>
                  <widget class="GtkLabel" id="label7">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <property name="label" translatable="yes">&lt;b&gt;Connection&lt;/b&gt;</property>
                    <property name="use_markup">True</property>
                  </widget>
                  <packing>
                    <property name="type">label_item</property>
                  </packing>
                </child>
              </widget>
              <packing>
                <property name="right_attach">3</property>
                <property name="top_attach">1</property>
                <property name="bottom_attach">2</property>
                <property name="x_padding">12</property>
                <property name="y_padding">10</property>
              </packing>
            </child>
            <child>
              <widget class="GtkFrame" id="frame1">
                <property name="visible">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="label_xalign">0</property>
                <property name="shadow_type">GTK_SHADOW_NONE</property>
                <child>
                  <widget class="GtkAlignment" id="alignment3">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <child>
                      <widget class="GtkTable" id="table2">
                        <property name="visible">True</property>
                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                        <property name="border_width">10</property>
                        <property name="n_rows">4</property>
                        <property name="n_columns">2</property>
                        <property name="column_spacing">7</property>
                        <property name="row_spacing">5</property>
                        <child>
                          <widget class="GtkSpinButton" id="midiin">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">0 0 100 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="midiout">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">0 0 100 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">3</property>
                            <property name="bottom_attach">4</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label4">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Midi OUT:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">3</property>
                            <property name="bottom_attach">4</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="audioout">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">0 0 100 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkSpinButton" id="audioin">
                            <property name="visible">True</property>
                            <property name="can_focus">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="adjustment">0 0 100 1 10 10</property>
                            <property name="snap_to_ticks">True</property>
                            <property name="numeric">True</property>
                          </widget>
                          <packing>
                            <property name="left_attach">1</property>
                            <property name="right_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label3">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Midi IN:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">2</property>
                            <property name="bottom_attach">3</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label2">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Audio OUT:</property>
                          </widget>
                          <packing>
                            <property name="top_attach">1</property>
                            <property name="bottom_attach">2</property>
                          </packing>
                        </child>
                        <child>
                          <widget class="GtkLabel" id="label1">
                            <property name="visible">True</property>
                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                            <property name="xalign">0</property>
                            <property name="label" translatable="yes">Audio IN:</property>
                          </widget>
                        </child>
                      </widget>
                    </child>
                  </widget>
                </child>
                <child>
                  <widget class="GtkLabel" id="label6">
                    <property name="visible">True</property>
                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                    <property name="label" translatable="yes">&lt;b&gt;Channels&lt;/b&gt;</property>
                    <property name="use_markup">True</property>
                  </widget>
                  <packing>
                    <property name="type">label_item</property>
                  </packing>
                </child>
              </widget>
              <packing>
                <property name="left_attach">1</property>
                <property name="right_attach">3</property>
                <property name="x_padding">12</property>
                <property name="y_padding">12</property>
              </packing>
            </child>
          </widget>
          <packing>
            <property name="position">1</property>
          </packing>
        </child>
        <child internal-child="action_area">
          <widget class="GtkHButtonBox" id="dialog-action_area1">
            <property name="visible">True</property>
            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
            <property name="layout_style">GTK_BUTTONBOX_END</property>
            <child>
              <widget class="GtkButton" id="button5">
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="label" translatable="yes">gtk-cancel</property>
                <property name="use_stock">True</property>
                <property name="response_id">0</property>
                <signal name="clicked" handler="config_cancel"/>
              </widget>
            </child>
            <child>
              <widget class="GtkButton" id="button4">
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                <property name="label" translatable="yes">gtk-ok</property>
                <property name="use_stock">True</property>
                <property name="response_id">0</property>
                <signal name="clicked" handler="config_ok"/>
              </widget>
              <packing>
                <property name="position">1</property>
              </packing>
            </child>
          </widget>
          <packing>
            <property name="expand">False</property>
            <property name="pack_type">GTK_PACK_END</property>
          </packing>
        </child>
      </widget>
    </child>
  </widget>
</glade-interface>
"""

class LinkType(int):
	pass



configfilename = os.environ['HOME'] + '/.gtknetsource'

confkeys = ['audioin', 'audioout', 'midiin', 'midiout', 'quality', 'latency', 'port', 'replyport', 'hostname',
	    'linktype', 'portdefault', 'replydefault' ]
config = { 'audioin': 2, 'audioout': 2, 'midiin': 1, 'midiout': 1, 'quality': 32, 'latency': 2, 'port': 3000, 'replyport': 3001,
		'hostname': "localhost", 'linktype': LinkType(0), 'portdefault': True, 'replydefault': True }


class NetSource:
	def __init__( self ):
		self.reset()

	def reset( self ):
		self.connected = False
		self.xruns = 0
		self.latency = 0
		self.netsource_child = 0
		self.netsource_watch = 0
		self.want_connect = False
		self.packets_seen = False;

	def child_output( self, src, cond ):
		s = src.readline()
		s = s.strip()

		if s=="Connected :-)":
			self.connected = True
			self.packets_seen = True
		if s=="Not Connected":
			self.connected = False
			self.latency = 0
		if "at frame" in s:
			self.xruns = int(s.split()[-1])
		if "current latency" in s:
			self.latency = int(s.split()[-1])
			self.packets_seen = True

		if self.connected:
			info = "<b>Status:</b> Connected   <b>xruns:</b> %d  <b>latency:</b> %d LOCKED" % (self.xruns, config['latency'] )
			
		elif self.packets_seen and self.latency != 0:
			info = "<b>Status:</b> Trying to Lock   <b>latency:</b> %d  <b>want:</b> %d" % (self.latency, config['latency'] )
		elif self.packets_seen:
			info = "<b>Status:</b> Connection Lost"
		else:
			info = "<b>Status:</b> Connecting"
			


		w = xml.get_widget( "info" )
		w.set_markup( info )
		return True

	def connect_handler( self ):

		self.want_connect = True
		if( self.netsource_watch==0 ):
			cmd = 'jack_netsource '

			cmd += '-h "%s" ' % ( config['hostname'] )

			cmd += '-P %d '   % ( config['audioout'] )
			cmd += '-C %d '   % ( config['audioin'] )
			cmd += '-o %d '   % ( config['midiout'] )
			cmd += '-i %d '   % ( config['midiin'] )

			cmd += '-l %d '   % ( config['latency'] )

			if not config['portdefault']:
				cmd += '-p %d '   % ( config['port'] )
			if not config['replydefault']:
				cmd += '-r %d '   % ( config['replyport'] )
			if config['linktype'] == 0:
				cmd += '-c %d '   % ( config['quality'] )
			if config['linktype'] == 2:
				cmd += '-b 16 '

			info = xml.get_widget( "info" )
			info.set_markup( "<b>Status:</b> Starting..." );
			self.netsource_child = subprocess.Popen(cmd, shell=True, bufsize=1, stdout=subprocess.PIPE, close_fds=True )
			self.netsource_watch = gobject.io_add_watch( self.netsource_child.stdout, gobject.IO_IN, self.child_output )

	def disconnect_handler( self ):
		self.want_connect = False
		if( self.netsource_watch != 0 ):
			gobject.source_remove( self.netsource_watch )
			self.netsource_watch = 0
			os.kill( self.netsource_child.pid, 15 )
			self.netsource_child.wait()
		info = xml.get_widget( "info" )
		info.set_markup( "<b>Status:</b> Deactivated" );

def prefs_handler( widget ):
	config_dialog = xml.get_widget( "configdialog" )
	config_dialog.show()

def config_ok( widget ):
	for i in confkeys:
		w = xml.get_widget( i )
		if type(config[i]) == int:
			config[i] = w.get_value()
		if type(config[i]) == float:
			config[i] = w.get_value()
		if type(config[i]) == str:
			config[i] = w.get_text()
		if type(config[i]) == LinkType:
			config[i] = LinkType( w.get_active() )
		if type(config[i]) == bool:
			config[i] = bool( w.get_active() )

	configfile = file( configfilename, "w" )
	pickle.dump( config, configfile ) 

	config_dialog = xml.get_widget( "configdialog" )
	config_dialog.hide()

def set_dialog_to_config():
	for i in confkeys:
		w = xml.get_widget( i )
		if type(config[i]) == int:
			w.set_value( config[i] )
		if type(config[i]) == float:
			w.set_value( config[i] )
		if type(config[i]) == str:
			w.set_text( config[i] )
		if type(config[i]) == LinkType:
			w.set_active( config[i] )
		if type(config[i]) == bool:
			w.set_active( config[i] )
			if( not config[i] ):
				for k in w.get_group():
					k.set_active(True)

def config_cancel( widget ):

	set_dialog_to_config()
	config_dialog = xml.get_widget( "configdialog" )
	config_dialog.hide()

def close_window( widget ):
	netsource.disconnect_handler()
	gtk.main_quit()

def start_handler( widget ):
	label = xml.get_widget( "start_label" )
	if netsource.want_connect:
		label.set_text( "Start" )
		netsource.disconnect_handler()
	else:
		label.set_text( "Stop" )
		netsource.connect_handler()


netsource = NetSource()

#xml = gtk.glade.XML( "gtknetsource.glade" )
xml = gtk.glade.xml_new_from_buffer( gladefile, len(gladefile) )
xml.signal_autoconnect( { 
	'close_window': close_window,
	'start': start_handler,
	'prefs': prefs_handler,
	'config_ok': config_ok,
	'config_cancel': config_cancel } )

try:
	configfile = file( configfilename )
	config = pickle.load( configfile )
except:
	configfile = file( configfilename, "w" )
	pickle.dump( config, configfile ) 

set_dialog_to_config()

gtk.main()

